Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 584)
+++ lemon/concepts/graph_components.h	(revision 534)
@@ -21,4 +21,5 @@
 ///\brief The concept of graph components.
 
+
 #ifndef LEMON_CONCEPTS_GRAPH_COMPONENTS_H
 #define LEMON_CONCEPTS_GRAPH_COMPONENTS_H
@@ -32,16 +33,17 @@
   namespace concepts {
 
-    /// \brief Concept class for \c Node, \c Arc and \c Edge types.
-    ///
-    /// This class describes the concept of \c Node, \c Arc and \c Edge
-    /// subtypes of digraph and graph types.
+    /// \brief Skeleton class for graph Node and Arc types
+    ///
+    /// This class describes the interface of Node and Arc (and Edge
+    /// in undirected graphs) subtypes of graph types.
     ///
     /// \note This class is a template class so that we can use it to
-    /// create graph skeleton classes. The reason for this is that \c Node
-    /// and \c Arc (or \c Edge) types should \e not derive from the same 
-    /// base class. For \c Node you should instantiate it with character
-    /// \c 'n', for \c Arc with \c 'a' and for \c Edge with \c 'e'.
+    /// create graph skeleton classes. The reason for this is than Node
+    /// and Arc types should \em not derive from the same base class.
+    /// For Node you should instantiate it with character 'n' and for Arc
+    /// with 'a'.
+
 #ifndef DOXYGEN
-    template <char sel = '0'>
+    template <char _selector = '0'>
 #endif
     class GraphItem {
@@ -49,47 +51,43 @@
       /// \brief Default constructor.
       ///
-      /// Default constructor.
       /// \warning The default constructor is not required to set
       /// the item to some well-defined value. So you should consider it
       /// as uninitialized.
       GraphItem() {}
-
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
+      ///
       GraphItem(const GraphItem &) {}
-
-      /// \brief Constructor for conversion from \c INVALID.
-      ///
-      /// Constructor for conversion from \c INVALID.
-      /// It initializes the item to be invalid.
+      /// \brief Invalid constructor \& conversion.
+      ///
+      /// This constructor initializes the item to be invalid.
       /// \sa Invalid for more details.
       GraphItem(Invalid) {}
-
-      /// \brief Assignment operator.
-      ///
-      /// Assignment operator for the item.
-      GraphItem& operator=(const GraphItem&) { return *this; }
-
+      /// \brief Assign operator for nodes.
+      ///
+      /// The nodes are assignable.
+      ///
+      GraphItem& operator=(GraphItem const&) { return *this; }
       /// \brief Equality operator.
       ///
-      /// Equality operator.
-      bool operator==(const GraphItem&) const { return false; }
-
+      /// Two iterators are equal if and only if they represents the
+      /// same node in the graph or both are invalid.
+      bool operator==(GraphItem) const { return false; }
       /// \brief Inequality operator.
       ///
-      /// Inequality operator.
-      bool operator!=(const GraphItem&) const { return false; }
-
-      /// \brief Ordering operator.
-      ///
-      /// This operator defines an ordering of the items.
-      /// It makes possible to use graph item types as key types in 
-      /// associative containers (e.g. \c std::map).
+      /// \sa operator==(const Node& n)
+      ///
+      bool operator!=(GraphItem) const { return false; }
+
+      /// \brief Artificial ordering operator.
+      ///
+      /// To allow the use of graph descriptors as key type in std::map or
+      /// similar associative container we require this.
       ///
       /// \note This operator only have to define some strict ordering of
       /// the items; this order has nothing to do with the iteration
       /// ordering of the items.
-      bool operator<(const GraphItem&) const { return false; }
+      bool operator<(GraphItem) const { return false; }
 
       template<typename _GraphItem>
@@ -103,4 +101,5 @@
 
           bool b;
+          //          b = (ia == ib) && (ia != ib) && (ia < ib);
           b = (ia == ib) && (ia != ib);
           b = (ia == INVALID) && (ib != INVALID);
@@ -113,10 +112,11 @@
     };
 
-    /// \brief Base skeleton class for directed graphs.
-    ///
-    /// This class describes the base interface of directed graph types.
-    /// All digraph %concepts have to conform to this class.
-    /// It just provides types for nodes and arcs and functions 
-    /// to get the source and the target nodes of arcs.
+    /// \brief An empty base directed graph class.
+    ///
+    /// This class provides the minimal set of features needed for a
+    /// directed graph structure. All digraph concepts have to
+    /// conform to this base directed graph. It just provides types
+    /// for nodes and arcs and functions to get the source and the
+    /// target of the arcs.
     class BaseDigraphComponent {
     public:
@@ -126,25 +126,29 @@
       /// \brief Node class of the digraph.
       ///
-      /// This class represents the nodes of the digraph.
+      /// This class represents the Nodes of the digraph.
+      ///
       typedef GraphItem<'n'> Node;
 
       /// \brief Arc class of the digraph.
       ///
-      /// This class represents the arcs of the digraph.
-      typedef GraphItem<'a'> Arc;
-
-      /// \brief Return the source node of an arc.
-      ///
-      /// This function returns the source node of an arc.
-      Node source(const Arc&) const { return INVALID; }
-
-      /// \brief Return the target node of an arc.
-      ///
-      /// This function returns the target node of an arc.
-      Node target(const Arc&) const { return INVALID; }
-
-      /// \brief Return the opposite node on the given arc.
-      ///
-      /// This function returns the opposite node on the given arc.
+      /// This class represents the Arcs of the digraph.
+      ///
+      typedef GraphItem<'e'> Arc;
+
+      /// \brief Gives back the target node of an arc.
+      ///
+      /// Gives back the target node of an arc.
+      ///
+      Node target(const Arc&) const { return INVALID;}
+
+      /// \brief Gives back the source node of an arc.
+      ///
+      /// Gives back the source node of an arc.
+      ///
+      Node source(const Arc&) const { return INVALID;}
+
+      /// \brief Gives back the opposite node on the given arc.
+      ///
+      /// Gives back the opposite node on the given arc.
       Node oppositeNode(const Node&, const Arc&) const {
         return INVALID;
@@ -172,55 +176,50 @@
     };
 
-    /// \brief Base skeleton class for undirected graphs.
-    ///
-    /// This class describes the base interface of undirected graph types.
-    /// All graph %concepts have to conform to this class.
-    /// It extends the interface of \ref BaseDigraphComponent with an
-    /// \c Edge type and functions to get the end nodes of edges,
-    /// to convert from arcs to edges and to get both direction of edges.
+    /// \brief An empty base undirected graph class.
+    ///
+    /// This class provides the minimal set of features needed for an
+    /// undirected graph structure. All undirected graph concepts have
+    /// to conform to this base graph. It just provides types for
+    /// nodes, arcs and edges and functions to get the
+    /// source and the target of the arcs and edges,
+    /// conversion from arcs to edges and function to get
+    /// both direction of the edges.
     class BaseGraphComponent : public BaseDigraphComponent {
     public:
       typedef BaseDigraphComponent::Node Node;
       typedef BaseDigraphComponent::Arc Arc;
-
-      /// \brief Undirected edge class of the graph.
-      ///
-      /// This class represents the undirected edges of the graph.
-      /// Undirected graphs can be used as directed graphs, each edge is
-      /// represented by two opposite directed arcs.
-      class Edge : public GraphItem<'e'> {
+      /// \brief Undirected arc class of the graph.
+      ///
+      /// This class represents the edges of the graph.
+      /// The undirected graphs can be used as a directed graph which
+      /// for each arc contains the opposite arc too so the graph is
+      /// bidirected. The edge represents two opposite
+      /// directed arcs.
+      class Edge : public GraphItem<'u'> {
       public:
-        typedef GraphItem<'e'> Parent;
-
+        typedef GraphItem<'u'> Parent;
         /// \brief Default constructor.
         ///
-        /// Default constructor.
         /// \warning The default constructor is not required to set
         /// the item to some well-defined value. So you should consider it
         /// as uninitialized.
         Edge() {}
-
         /// \brief Copy constructor.
         ///
         /// Copy constructor.
+        ///
         Edge(const Edge &) : Parent() {}
-
-        /// \brief Constructor for conversion from \c INVALID.
-        ///
-        /// Constructor for conversion from \c INVALID.
-        /// It initializes the item to be invalid.
+        /// \brief Invalid constructor \& conversion.
+        ///
+        /// This constructor initializes the item to be invalid.
         /// \sa Invalid for more details.
         Edge(Invalid) {}
-
-        /// \brief Constructor for conversion from an arc.
-        ///
-        /// Constructor for conversion from an arc.
+        /// \brief Converter from arc to edge.
+        ///
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
         Edge(const Arc&) {}
-
-        /// \brief Assign an arc to an edge.
-        ///
-        /// This function assigns an arc to an edge.
+        /// \brief Assign arc to edge.
+        ///
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
@@ -228,27 +227,5 @@
       };
 
-      /// \brief Return one end node of an edge.
-      ///
-      /// This function returns one end node of an edge.
-      Node u(const Edge&) const { return INVALID; }
-
-      /// \brief Return the other end node of an edge.
-      ///
-      /// This function returns the other end node of an edge.
-      Node v(const Edge&) const { return INVALID; }
-
-      /// \brief Return a directed arc related to an edge.
-      ///
-      /// This function returns a directed arc from its direction and the
-      /// represented edge.
-      Arc direct(const Edge&, bool) const { return INVALID; }
-
-      /// \brief Return a directed arc related to an edge.
-      ///
-      /// This function returns a directed arc from its source node and the
-      /// represented edge.
-      Arc direct(const Edge&, const Node&) const { return INVALID; }
-
-      /// \brief Return the direction of the arc.
+      /// \brief Returns the direction of the arc.
       ///
       /// Returns the direction of the arc. Each arc represents an
@@ -257,9 +234,31 @@
       bool direction(const Arc&) const { return true; }
 
-      /// \brief Return the opposite arc.
-      ///
-      /// This function returns the opposite arc, i.e. the arc representing
-      /// the same edge and has opposite direction.
-      Arc oppositeArc(const Arc&) const { return INVALID; }
+      /// \brief Returns the directed arc.
+      ///
+      /// Returns the directed arc from its direction and the
+      /// represented edge.
+      Arc direct(const Edge&, bool) const { return INVALID;}
+
+      /// \brief Returns the directed arc.
+      ///
+      /// Returns the directed arc from its source and the
+      /// represented edge.
+      Arc direct(const Edge&, const Node&) const { return INVALID;}
+
+      /// \brief Returns the opposite arc.
+      ///
+      /// Returns the opposite arc. It is the arc representing the
+      /// same edge and has opposite direction.
+      Arc oppositeArc(const Arc&) const { return INVALID;}
+
+      /// \brief Gives back one ending of an edge.
+      ///
+      /// Gives back one ending of an edge.
+      Node u(const Edge&) const { return INVALID;}
+
+      /// \brief Gives back the other ending of an edge.
+      ///
+      /// Gives back the other ending of an edge.
+      Node v(const Edge&) const { return INVALID;}
 
       template <typename _Graph>
@@ -271,5 +270,5 @@
         void constraints() {
           checkConcept<BaseDigraphComponent, _Graph>();
-          checkConcept<GraphItem<'e'>, Edge>();
+          checkConcept<GraphItem<'u'>, Edge>();
           {
             Node n;
@@ -279,5 +278,4 @@
             n = graph.v(ue);
             e = graph.direct(ue, true);
-            e = graph.direct(ue, false);
             e = graph.direct(ue, n);
             e = graph.oppositeArc(e);
@@ -293,55 +291,57 @@
     };
 
-    /// \brief Skeleton class for \e idable directed graphs.
-    ///
-    /// This class describes the interface of \e idable directed graphs.
-    /// It extends \ref BaseDigraphComponent with the core ID functions.
-    /// The ids of the items must be unique and immutable.
-    /// This concept is part of the Digraph concept.
-    template <typename BAS = BaseDigraphComponent>
-    class IDableDigraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
+    /// \brief An empty idable base digraph class.
+    ///
+    /// This class provides beside the core digraph features
+    /// core id functions for the digraph structure.
+    /// The most of the base digraphs should conform to this concept.
+    /// The id's are unique and immutable.
+    template <typename _Base = BaseDigraphComponent>
+    class IDableDigraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
 
-      /// \brief Return a unique integer id for the given node.
-      ///
-      /// This function returns a unique integer id for the given node.
-      int id(const Node&) const { return -1; }
-
-      /// \brief Return the node by its unique id.
-      ///
-      /// This function returns the node by its unique id.
-      /// If the digraph does not contain a node with the given id,
-      /// then the result of the function is undefined.
-      Node nodeFromId(int) const { return INVALID; }
-
-      /// \brief Return a unique integer id for the given arc.
-      ///
-      /// This function returns a unique integer id for the given arc.
-      int id(const Arc&) const { return -1; }
-
-      /// \brief Return the arc by its unique id.
-      ///
-      /// This function returns the arc by its unique id.
-      /// If the digraph does not contain an arc with the given id,
-      /// then the result of the function is undefined.
-      Arc arcFromId(int) const { return INVALID; }
-
-      /// \brief Return an integer greater or equal to the maximum
-      /// node id.
-      ///
-      /// This function returns an integer greater or equal to the
-      /// maximum node id.
-      int maxNodeId() const { return -1; }
-
-      /// \brief Return an integer greater or equal to the maximum
-      /// arc id.
-      ///
-      /// This function returns an integer greater or equal to the
-      /// maximum arc id.
-      int maxArcId() const { return -1; }
+      /// \brief Gives back an unique integer id for the Node.
+      ///
+      /// Gives back an unique integer id for the Node.
+      ///
+      int id(const Node&) const { return -1;}
+
+      /// \brief Gives back the node by the unique id.
+      ///
+      /// Gives back the node by the unique id.
+      /// If the digraph does not contain node with the given id
+      /// then the result of the function is undetermined.
+      Node nodeFromId(int) const { return INVALID;}
+
+      /// \brief Gives back an unique integer id for the Arc.
+      ///
+      /// Gives back an unique integer id for the Arc.
+      ///
+      int id(const Arc&) const { return -1;}
+
+      /// \brief Gives back the arc by the unique id.
+      ///
+      /// Gives back the arc by the unique id.
+      /// If the digraph does not contain arc with the given id
+      /// then the result of the function is undetermined.
+      Arc arcFromId(int) const { return INVALID;}
+
+      /// \brief Gives back an integer greater or equal to the maximum
+      /// Node id.
+      ///
+      /// Gives back an integer greater or equal to the maximum Node
+      /// id.
+      int maxNodeId() const { return -1;}
+
+      /// \brief Gives back an integer greater or equal to the maximum
+      /// Arc id.
+      ///
+      /// Gives back an integer greater or equal to the maximum Arc
+      /// id.
+      int maxArcId() const { return -1;}
 
       template <typename _Digraph>
@@ -369,38 +369,38 @@
     };
 
-    /// \brief Skeleton class for \e idable undirected graphs.
-    ///
-    /// This class describes the interface of \e idable undirected
-    /// graphs. It extends \ref IDableDigraphComponent with the core ID
-    /// functions of undirected graphs.
-    /// The ids of the items must be unique and immutable.
-    /// This concept is part of the Graph concept.
-    template <typename BAS = BaseGraphComponent>
-    class IDableGraphComponent : public IDableDigraphComponent<BAS> {
-    public:
-
-      typedef BAS Base;
+    /// \brief An empty idable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core id functions for the undirected graph structure.  The
+    /// most of the base undirected graphs should conform to this
+    /// concept.  The id's are unique and immutable.
+    template <typename _Base = BaseGraphComponent>
+    class IDableGraphComponent : public IDableDigraphComponent<_Base> {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Edge Edge;
 
-      using IDableDigraphComponent<Base>::id;
-
-      /// \brief Return a unique integer id for the given edge.
-      ///
-      /// This function returns a unique integer id for the given edge.
-      int id(const Edge&) const { return -1; }
-
-      /// \brief Return the edge by its unique id.
-      ///
-      /// This function returns the edge by its unique id.
-      /// If the graph does not contain an edge with the given id,
-      /// then the result of the function is undefined.
-      Edge edgeFromId(int) const { return INVALID; }
-
-      /// \brief Return an integer greater or equal to the maximum
-      /// edge id.
-      ///
-      /// This function returns an integer greater or equal to the
-      /// maximum edge id.
-      int maxEdgeId() const { return -1; }
+      using IDableDigraphComponent<_Base>::id;
+
+      /// \brief Gives back an unique integer id for the Edge.
+      ///
+      /// Gives back an unique integer id for the Edge.
+      ///
+      int id(const Edge&) const { return -1;}
+
+      /// \brief Gives back the edge by the unique id.
+      ///
+      /// Gives back the edge by the unique id.  If the
+      /// graph does not contain arc with the given id then the
+      /// result of the function is undetermined.
+      Edge edgeFromId(int) const { return INVALID;}
+
+      /// \brief Gives back an integer greater or equal to the maximum
+      /// Edge id.
+      ///
+      /// Gives back an integer greater or equal to the maximum Edge
+      /// id.
+      int maxEdgeId() const { return -1;}
 
       template <typename _Graph>
@@ -408,4 +408,5 @@
 
         void constraints() {
+          checkConcept<Base, _Graph >();
           checkConcept<IDableDigraphComponent<Base>, _Graph >();
           typename _Graph::Edge edge;
@@ -421,59 +422,50 @@
     };
 
-    /// \brief Concept class for \c NodeIt, \c ArcIt and \c EdgeIt types.
-    ///
-    /// This class describes the concept of \c NodeIt, \c ArcIt and 
-    /// \c EdgeIt subtypes of digraph and graph types.
-    template <typename GR, typename Item>
-    class GraphItemIt : public Item {
+    /// \brief Skeleton class for graph NodeIt and ArcIt
+    ///
+    /// Skeleton class for graph NodeIt and ArcIt.
+    ///
+    template <typename _Graph, typename _Item>
+    class GraphItemIt : public _Item {
     public:
       /// \brief Default constructor.
       ///
-      /// Default constructor.
-      /// \warning The default constructor is not required to set
-      /// the iterator to some well-defined value. So you should consider it
-      /// as uninitialized.
+      /// @warning The default constructor sets the iterator
+      /// to an undefined value.
       GraphItemIt() {}
-
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      GraphItemIt(const GraphItemIt& it) : Item(it) {}
-
-      /// \brief Constructor that sets the iterator to the first item.
-      ///
-      /// Constructor that sets the iterator to the first item.
-      explicit GraphItemIt(const GR&) {}
-
-      /// \brief Constructor for conversion from \c INVALID.
-      ///
-      /// Constructor for conversion from \c INVALID.
-      /// It initializes the iterator to be invalid.
+      ///
+      GraphItemIt(const GraphItemIt& ) {}
+      /// \brief Sets the iterator to the first item.
+      ///
+      /// Sets the iterator to the first item of \c the graph.
+      ///
+      explicit GraphItemIt(const _Graph&) {}
+      /// \brief Invalid constructor \& conversion.
+      ///
+      /// This constructor initializes the item to be invalid.
       /// \sa Invalid for more details.
       GraphItemIt(Invalid) {}
-
-      /// \brief Assignment operator.
-      ///
-      /// Assignment operator for the iterator.
+      /// \brief Assign operator for items.
+      ///
+      /// The items are assignable.
+      ///
       GraphItemIt& operator=(const GraphItemIt&) { return *this; }
-
-      /// \brief Increment the iterator.
-      ///
-      /// This operator increments the iterator, i.e. assigns it to the
-      /// next item.
+      /// \brief Next item.
+      ///
+      /// Assign the iterator to the next item.
+      ///
       GraphItemIt& operator++() { return *this; }
- 
       /// \brief Equality operator
       ///
-      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
       bool operator==(const GraphItemIt&) const { return true;}
-
       /// \brief Inequality operator
       ///
-      /// Inequality operator.
-      /// Two iterators are equal if and only if they point to the
-      /// same object or both are invalid.
+      /// \sa operator==(Node n)
+      ///
       bool operator!=(const GraphItemIt&) const { return true;}
 
@@ -481,9 +473,6 @@
       struct Constraints {
         void constraints() {
-          checkConcept<GraphItem<>, _GraphItemIt>();
           _GraphItemIt it1(g);
           _GraphItemIt it2;
-          _GraphItemIt it3 = it1;
-          _GraphItemIt it4 = INVALID;
 
           it2 = ++it1;
@@ -491,68 +480,58 @@
           ++(++it1);
 
-          Item bi = it1;
+          _Item bi = it1;
           bi = it2;
         }
-        const GR& g;
-      };
-    };
-
-    /// \brief Concept class for \c InArcIt, \c OutArcIt and 
-    /// \c IncEdgeIt types.
-    ///
-    /// This class describes the concept of \c InArcIt, \c OutArcIt 
-    /// and \c IncEdgeIt subtypes of digraph and graph types.
-    ///
-    /// \note Since these iterator classes do not inherit from the same
-    /// base class, there is an additional template parameter (selector)
-    /// \c sel. For \c InArcIt you should instantiate it with character 
-    /// \c 'i', for \c OutArcIt with \c 'o' and for \c IncEdgeIt with \c 'e'.
-    template <typename GR,
-              typename Item = typename GR::Arc,
-              typename Base = typename GR::Node,
-              char sel = '0'>
-    class GraphIncIt : public Item {
+        _Graph& g;
+      };
+    };
+
+    /// \brief Skeleton class for graph InArcIt and OutArcIt
+    ///
+    /// \note Because InArcIt and OutArcIt may not inherit from the same
+    /// base class, the _selector is a additional template parameter. For
+    /// InArcIt you should instantiate it with character 'i' and for
+    /// OutArcIt with 'o'.
+    template <typename _Graph,
+              typename _Item = typename _Graph::Arc,
+              typename _Base = typename _Graph::Node,
+              char _selector = '0'>
+    class GraphIncIt : public _Item {
     public:
       /// \brief Default constructor.
       ///
-      /// Default constructor.
-      /// \warning The default constructor is not required to set
-      /// the iterator to some well-defined value. So you should consider it
-      /// as uninitialized.
+      /// @warning The default constructor sets the iterator
+      /// to an undefined value.
       GraphIncIt() {}
-
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      GraphIncIt(const GraphIncIt& it) : Item(it) {}
-
-      /// \brief Constructor that sets the iterator to the first 
-      /// incoming or outgoing arc.
-      ///
-      /// Constructor that sets the iterator to the first arc 
-      /// incoming to or outgoing from the given node.
-      explicit GraphIncIt(const GR&, const Base&) {}
-
-      /// \brief Constructor for conversion from \c INVALID.
-      ///
-      /// Constructor for conversion from \c INVALID.
-      /// It initializes the iterator to be invalid.
+      ///
+      GraphIncIt(GraphIncIt const& gi) : _Item(gi) {}
+      /// \brief Sets the iterator to the first arc incoming into or outgoing
+      /// from the node.
+      ///
+      /// Sets the iterator to the first arc incoming into or outgoing
+      /// from the node.
+      ///
+      explicit GraphIncIt(const _Graph&, const _Base&) {}
+      /// \brief Invalid constructor \& conversion.
+      ///
+      /// This constructor initializes the item to be invalid.
       /// \sa Invalid for more details.
       GraphIncIt(Invalid) {}
-
-      /// \brief Assignment operator.
-      ///
-      /// Assignment operator for the iterator.
-      GraphIncIt& operator=(const GraphIncIt&) { return *this; }
-
-      /// \brief Increment the iterator.
-      ///
-      /// This operator increments the iterator, i.e. assigns it to the
-      /// next arc incoming to or outgoing from the given node.
+      /// \brief Assign operator for iterators.
+      ///
+      /// The iterators are assignable.
+      ///
+      GraphIncIt& operator=(GraphIncIt const&) { return *this; }
+      /// \brief Next item.
+      ///
+      /// Assign the iterator to the next item.
+      ///
       GraphIncIt& operator++() { return *this; }
 
       /// \brief Equality operator
       ///
-      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
@@ -561,7 +540,6 @@
       /// \brief Inequality operator
       ///
-      /// Inequality operator.
-      /// Two iterators are equal if and only if they point to the
-      /// same object or both are invalid.
+      /// \sa operator==(Node n)
+      ///
       bool operator!=(const GraphIncIt&) const { return true;}
 
@@ -569,33 +547,35 @@
       struct Constraints {
         void constraints() {
-          checkConcept<GraphItem<sel>, _GraphIncIt>();
+          checkConcept<GraphItem<_selector>, _GraphIncIt>();
           _GraphIncIt it1(graph, node);
           _GraphIncIt it2;
-          _GraphIncIt it3 = it1;
-          _GraphIncIt it4 = INVALID;
 
           it2 = ++it1;
           ++it2 = it1;
           ++(++it1);
-          Item e = it1;
+          _Item e = it1;
           e = it2;
-        }
-        const Base& node;
-        const GR& graph;
-      };
-    };
-
-    /// \brief Skeleton class for iterable directed graphs.
-    ///
-    /// This class describes the interface of iterable directed
-    /// graphs. It extends \ref BaseDigraphComponent with the core
-    /// iterable interface.
+
+        }
+
+        _Item arc;
+        _Base node;
+        _Graph graph;
+        _GraphIncIt it;
+      };
+    };
+
+
+    /// \brief An empty iterable digraph class.
+    ///
+    /// This class provides beside the core digraph features
+    /// iterator based iterable interface for the digraph structure.
     /// This concept is part of the Digraph concept.
-    template <typename BAS = BaseDigraphComponent>
-    class IterableDigraphComponent : public BAS {
-
-    public:
-
-      typedef BAS Base;
+    template <typename _Base = BaseDigraphComponent>
+    class IterableDigraphComponent : public _Base {
+
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
